#include "MyStrings.h"
#include <string>
#include <string.h>
#include <stdlib.h>
#include <assert.h> 



/****************************************************
 *@brief StrInsert Insert the src string
 *@param dst Destination String
 *@param src Source String to insert
 *@param pos where to insert
 * **************************************************/
char* StrInsert(char * dst,const char * src,const int pos)
{          
    assert(dst!=NULL && src!=NULL && pos>=0);                           
    memmove(dst+pos+strlen(src), dst+pos, strlen(dst+pos)+1);             
    memmove(dst+pos, src, strlen(src));                                 
                                                                        
    return dst;                                                         
}  



/****************************************************
 *@brief StrDel Delete Part of String
 *@param dst Destination String
 *@param von from
 *@param bis to
 * **************************************************/
char* StrDel(char * dst, int von,int bis)
{                        
    memmove(dst+von, dst+bis+1, strlen(dst+bis+1));                         
    dst[strlen(dst)-(bis-von)]='\0';                                    
    return dst;      
}


/****************************************************
 *@brief StrIReplace Replace a String
 *@param dst Destination String
 *@param src Source String to insert
 *@param pos where to insert
 * **************************************************/
char* StrIReplace(char * dst,const char * src,const int pos)
{          
    assert(dst!=NULL && src!=NULL && pos>=0);                           
    memmove(dst+pos, src, strlen(src));                                 
    return dst;                                                         
}  

/****************************************************
 *@brief StrCopy Copy a Part of dst
  *@param src Source String to insert
 *@param from 
 *@param to
 *@return the copied Sting
 *@todo Result = new char[40]; not Perfect
 * **************************************************/
char * StrCopy(char *src,int from, int to )
{

char *Result;     
Result = new char[40]; 
int j = 0;
for (int i = from; i < from +to; i++)
{
Result[j] = *src++;
j++;

}
Result[to - from ] = '\0';
return (Result );
 delete [] Result;
}

/****************************************************
 *@brief StrCopy Copy a Part of dst
 *@param dst Destination
 *@param src Source String to insert
 *@param dsize to copy
 *@return copied size
 * **************************************************/
size_t strlcpy(char *dst, const char *src, size_t dsize)
{
	const char *osrc = src;
	size_t nleft = dsize;

	/* Copy as many bytes as will fit. */
	if (nleft != 0) {
		while (--nleft != 0) {
			if ((*dst++ = *src++) == '\0')
				break;
		}
	}
	/* Not enough room in dst, add NUL and traverse rest of src. */
	if (nleft == 0) {
		if (dsize != 0)
			*dst = '\0';		/* NUL-terminate dst */
		while (*src++)
			;
	}

	return(src - osrc - 1);	/* count does not include NUL */
}

/****************************************************
 *@brief  StrPos Poition of a Substring in String
 *@param haystack Source String
 *@param needle the Part to find 
 *@return Position of Found
 * **************************************************/
int StrPos(char * haystack,  char * needle)   // find 1st occurance of substr in str
{
   char *p = strstr(haystack, needle);
   if (p) return p - haystack;
   return -1;   // Not found = -1.
}




/****************************************************
 *@brief  CheckIfFree
 *@param Value Line to Check
 * **************************************************/
bool CheckIfFree(String Value)
{
  // We assume that Entry is empty
if (Value.length() < 10)
return(true);
else
return(false);
}



/****************************************************
 *@brief  DeleteKey2 in the ini File
 *@param Value Input Outpu
 *@param Key1 to delete
 *@param Key2 to delete 
 * **************************************************/

String DeleteKey2 (String Value, String Key1, String Key2)
{

int num;

if (Value.startsWith(Key1) )
{

num = Value.indexOf("=");
Value.remove(num + 1, 255);

}

if (Value.startsWith(Key2) )
{

num = Value.indexOf("=");
Value.remove(num + 1, 255);

}
return (Value +'\n');
}

/****************************************************
 *@brief SetEntries New count of Stations 
 *@param Value Input Outpu
 *@param EntryNew New Station Count
 ***************************************************/
String SetEntries(String Value, int EntryNew)
{
int num;
char Puffer[5];

 if (Value.startsWith("Stations ="))
 { 
 
 itoa(EntryNew,Puffer,10);
num = Value.indexOf("=");
Value.remove(num +1 , 255);
Value +=   " ";
Value +=   Puffer;
 }

return (Value + '\n');

}



/****************************************************
 *@brief AddNewKey2
 *@param Value Input Outpu
 *@param Value1 New Ini Content
 *@param Value2 New Ini Content
 ***************************************************/
String AddNewKey2(String Value, String Value1, String Value2)
{
String Key1 = "URL_";
String Key2 = "Name_";
static bool Done1 = false;
static bool Done2 = false;

Value.trim();

if (Done1 == false)
if (Value.startsWith(Key1))
{
if (CheckIfFree(Value))
{
Value += " " + Value1;
Done1 = true;
}
}

if (Done2 == false)
if (Value.startsWith(Key2))
{
if (CheckIfFree(Value))
{
Value += " " + Value2;
Done2 = true;
}
}
if (Value.startsWith("[Entries]"))
{
Done1 = false;
Done2 = false;
}

return (Value + "\n");

}






/****************************************************
 *@brief LineByLine 
 *@param bool &bNotDone
 *@param String Value
 ***************************************************/
String LineByLine(bool &bNotDone,String Value)
{
String TextLine;
static int  i = 0;
char ch;

bNotDone = true;

int l = Value.length();

for (i; i < l; i++)
{
 ch = Value[i];
 
TextLine += ch;

if (ch == '\n')
{
i++;
TextLine.trim();
return (TextLine);
}}
if (l == i) {
bNotDone = false;
i = 0;
}
return (TextLine + "\n");

}


