#pragma once

#include "Arduino.h"
#include "SPI.h"

#define TFT_WIDTH       320
#define TFT_HEIGHT      480

extern __attribute__((weak)) void tp_pressed(uint16_t x, uint16_t y, uint16_t mx, uint16_t my);
extern __attribute__((weak)) void tp_released();

class TP {

//Kalibrierung
//x,y | Ux,Uy  0  ,0     | 1922,1930
//x,y | Ux,Uy  320,0     |  140,1930
//x,y | Ux,Uy  0  ,480   | 1922,125
//x,y | Ux,Uy  320,480   |  140,125
//daraus ergib sich für x: (1922-140)/320 = 5,5687mV pro Pixel
//              und für y: (1930-125)/480 = 3,7604mV pro Pixel

    public:

        TP(uint8_t TP_CS, uint8_t TP_IRQ);
        void loop();
        void setRotation(uint8_t m);
    private:
        SPISettings TP_SPI;
        uint8_t TP_CS, TP_IRQ;
        uint16_t x=0, y=0;
        uint16_t mx=0, my=0;
        uint8_t _rotation;
        boolean f_loop=false;
        //const uint8_t TP_Dummy=0x80; //nur Startbit für XPT2046
        float xFaktor;
        float yFaktor;
        const uint16_t Xmax=1922;
        const uint16_t Xmin=140;
        const uint16_t Ymax=1930;
        const uint16_t Ymin=125;

    protected:
        uint16_t TP_Send(uint8_t set_val);
        bool read_TP(uint16_t& x, uint16_t& y, uint16_t& mx, uint16_t& my );
};